﻿//########################
//選択された文字をルビにします。
//[誕生日/たんじょうび]
//を選択すると誕生日にグループルビが付きます。
//[誕生日/たん.じょう.び]
//を選択すると誕生日にモノルビが付きます。
//たけうちとおる
//########################

var myDocu=app.activeDocument;
var selList=myDocu.selection;
var itemCount=selList.length;
if(itemCount==0){
	alert("テキストフレームを選択ツールで選択してください。");
}

var mySelLength = selList[0].characters.length;
for(var c = mySelLength-1;c > -1; c--){
//for(var c = 0;c < mySelLength; c++){
	selList[0].recompose();//★ここ//このスクリプトの場合再評価は必要ないようだ。
    var myCha = selList[0].characters[c].contents;
    if(myCha == "]"){var myEndCha = c;}
    else if(myCha == "["){
        var myStartCha = c;
        //selList[0].characters[myStartCha].contents="";
        setRuby(selList,myStartCha+1,myEndCha-1)
        selList=myDocu.selection;
    }
}

function setRuby(selList,myStartCha,myEndCha){
    var myStr = selList[0].characters.itemByRange(myStartCha, myEndCha).contents;
    var strAry = myStr[0].split("/");
    var kanji = strAry[0];
    var kanjiCount = kanji.length;
    var kana = strAry[1];
    var kanaAry = kana.split(".");
    var rubyCount = kanaAry.length;
    if(rubyCount == 0){
	//alert("「誕生日/たん,じょう,び」のようにしてください。");
    }else if(rubyCount == 1){
        selList[0].characters.itemByRange(myStartCha, myStartCha+kanjiCount-1).rubyString = kana;
        selList[0].characters.itemByRange(myStartCha, myStartCha+kanjiCount-1).rubyType = RubyTypes.GROUP_RUBY;
        selList[0].characters.itemByRange(myStartCha, myStartCha+kanjiCount-1).rubyFlag = true;
        selList[0].characters.itemByRange(myStartCha+kanjiCount, myEndCha+1).contents = "";
        selList=myDocu.selection;
        selList[0].characters[myStartCha-1].contents="";
    }else{
        for(var i = 0; i < kanjiCount;i++){
            selList[0].characters[myStartCha+i].rubyString = kanaAry[i];
            selList[0].characters[myStartCha+i].rubyFlag = true;
        }
        selList[0].characters.itemByRange(myStartCha+kanjiCount, myEndCha+1).contents = "";
        selList=myDocu.selection;
        selList[0].characters[myStartCha-1].contents="";
    }
}